VERSION 5.00
Begin VB.Form frmTestTrickVBDriver 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Test TrickMemReader driver"
   ClientHeight    =   2145
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   4935
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   143
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   329
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdRead 
      Caption         =   "Read"
      Default         =   -1  'True
      Height          =   360
      Left            =   2715
      TabIndex        =   3
      Top             =   1470
      Width           =   1305
   End
   Begin VB.TextBox txtAddress 
      Height          =   330
      Left            =   945
      TabIndex        =   2
      Text            =   "00000000"
      Top             =   1485
      Width           =   1605
   End
   Begin VB.PictureBox picDump 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   204
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1140
      Left            =   120
      ScaleHeight     =   72
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   302
      TabIndex        =   0
      Top             =   255
      Width           =   4590
   End
   Begin VB.Label lblAddress 
      Caption         =   "Address:"
      Height          =   240
      Left            =   135
      TabIndex        =   1
      Top             =   1515
      Width           =   765
   End
End
Attribute VB_Name = "frmTestTrickVBDriver"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' // frmTestTrickVBDriver.frm  -    
' //     (The trick), 2014

Option Explicit

Private Type SERVICE_STATUS
    dwServiceType               As Long
    dwCurrentState              As Long
    dwControlsAccepted          As Long
    dwWin32ExitCode             As Long
    dwServiceSpecificExitCode   As Long
    dwCheckPoint                As Long
    dwWaitHint                  As Long
End Type

Private Declare Function ControlService Lib "advapi32.dll" ( _
                         ByVal hService As Long, _
                         ByVal dwControl As Long, _
                         ByRef lpServiceStatus As SERVICE_STATUS) As Long
Private Declare Function OpenSCManager Lib "advapi32.dll" _
                         Alias "OpenSCManagerW" ( _
                         ByVal lpMachineName As Long, _
                         ByVal lpDatabaseName As Long, _
                         ByVal dwDesiredAccess As Long) As Long
Private Declare Function CloseServiceHandle Lib "advapi32.dll" ( _
                         ByVal hSCObject As Long) As Long
Private Declare Function OpenService Lib "advapi32.dll" _
                         Alias "OpenServiceW" ( _
                         ByVal hSCManager As Long, _
                         ByVal lpServiceName As Long, _
                         ByVal dwDesiredAccess As Long) As Long
Private Declare Function CreateService Lib "advapi32.dll" _
                         Alias "CreateServiceW" ( _
                         ByVal hSCManager As Long, _
                         ByVal lpServiceName As Long, _
                         ByVal lpDisplayName As Long, _
                         ByVal dwDesiredAccess As Long, _
                         ByVal dwServiceType As Long, _
                         ByVal dwStartType As Long, _
                         ByVal dwErrorControl As Long, _
                         ByVal lpBinaryPathName As Long, _
                         ByVal lpLoadOrderGroup As String, _
                         ByRef lpdwTagId As Long, _
                         ByVal lpDependencies As Long, _
                         ByVal lp As Long, _
                         ByVal lpPassword As Long) As Long
Private Declare Function StartService Lib "advapi32.dll" _
                         Alias "StartServiceW" ( _
                         ByVal hService As Long, _
                         ByVal dwNumServiceArgs As Long, _
                         ByVal lpServiceArgVectors As Long) As Long
Private Declare Function DeleteService Lib "advapi32.dll" ( _
                         ByVal hService As Long) As Long
Private Declare Function CreateFile Lib "kernel32" _
                         Alias "CreateFileW" ( _
                         ByVal lpFileName As Long, _
                         ByVal dwDesiredAccess As Long, _
                         ByVal dwShareMode As Long, _
                         ByRef lpSecurityAttributes As Any, _
                         ByVal dwCreationDisposition As Long, _
                         ByVal dwFlagsAndAttributes As Long, _
                         ByVal hTemplateFile As Long) As Long
Private Declare Function CloseHandle Lib "kernel32" ( _
                         ByVal hObject As Long) As Long
Private Declare Function DeviceIoControl Lib "kernel32" ( _
                         ByVal hDevice As Long, _
                         ByVal dwIoControlCode As Long, _
                         ByRef lpInBuffer As Any, _
                         ByVal nInBufferSize As Long, _
                         ByRef lpOutBuffer As Any, _
                         ByVal nOutBufferSize As Long, _
                         ByRef lpBytesReturned As Long, _
                         ByRef lpOverlapped As Any) As Long

Private Const ERROR_SERVICE_ALREADY_RUNNING As Long = 1056&
Private Const ERROR_SERVICE_EXISTS          As Long = 1073&
Private Const SERVICE_CONTROL_STOP          As Long = &H1
Private Const SC_MANAGER_ALL_ACCESS         As Long = &HF003F
Private Const SERVICE_ALL_ACCESS            As Long = &HF01FF
Private Const SERVICE_KERNEL_DRIVER         As Long = &H1
Private Const SERVICE_DEMAND_START          As Long = &H3
Private Const SERVICE_ERROR_NORMAL          As Long = &H1
Private Const GENERIC_READ                  As Long = &H80000000
Private Const GENERIC_WRITE                 As Long = &H40000000
Private Const FILE_SHARE_READ               As Long = &H1
Private Const FILE_SHARE_WRITE              As Long = &H2
Private Const OPEN_EXISTING                 As Long = 3
Private Const FILE_ATTRIBUTE_NORMAL         As Long = &H80
Private Const INVALID_HANDLE_VALUE          As Long = -1
Private Const IOCTL_READ_MEMORY             As Long = &H80002000

Private Const DriverName    As String = "TrickMemReader"
Private Const NumOfRows     As Long = 32

Private DriverFile  As String
Private hMgr        As Long
Private hSrv        As Long
Private hDev        As Long
Private buffer()    As Byte
Private bufLen      As Long
Private Address     As Long

' //       
Private Sub cmdRead_Click()
    Dim param(1)    As Long
    
    On Error GoTo Cancel
    
    Address = CLng("&H" & Trim(txtAddress.Text))
    
    ' //  
    param(0) = Address
    param(1) = 16 * NumOfRows
    
    ' //   
    If DeviceIoControl(hDev, IOCTL_READ_MEMORY, param(0), 8, buffer(0), UBound(buffer) + 1, bufLen, ByVal 0&) = 0 Then
        bufLen = 0
    End If
    
    Update
    
Cancel:
    
End Sub

Private Sub Form_Load()
    Dim sw  As Long
    Dim sh  As Long
    
    ' //  
    ReDim buffer(16 * NumOfRows - 1)
    
    ' //    
    DriverFile = App.Path & "\" & DriverName & ".sys"
    
    ' //     
    hMgr = OpenSCManager(0, 0, SC_MANAGER_ALL_ACCESS)
    
    If hMgr = 0 Then
        MsgBox "       "
        End
    End If
    
    ' //  
    hSrv = CreateService(hMgr, StrPtr(DriverName), StrPtr(DriverName), SERVICE_ALL_ACCESS, _
                        SERVICE_KERNEL_DRIVER, SERVICE_DEMAND_START, SERVICE_ERROR_NORMAL, StrPtr(DriverFile), _
                        0, 0, 0, 0, 0)
    ' //    
    If hSrv = 0 And Err.LastDllError = ERROR_SERVICE_EXISTS Then
        ' //  
        hSrv = OpenService(hMgr, StrPtr(DriverName), SERVICE_ALL_ACCESS)

    End If

    If hSrv = 0 Then
        MsgBox "   "
        Unload Me
        End
    End If
    
    ' //  
    If StartService(hSrv, 0, 0) = 0 Then
        
        If Err.LastDllError <> ERROR_SERVICE_ALREADY_RUNNING Then
            MsgBox "   "
            Unload Me
            End
        End If
        
    End If
    
    ' //   
    hDev = CreateFile(StrPtr("\\.\" & DriverName), GENERIC_READ Or FILE_SHARE_WRITE, FILE_SHARE_READ Or FILE_SHARE_WRITE, ByVal 0&, _
                        OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0)

    If hDev = INVALID_HANDLE_VALUE Then
        MsgBox "    "
        Unload Me
        End
    End If
    
    ' //       
    sw = picDump.TextWidth("_")
    sh = picDump.TextHeight("_")
    
    picDump.Move 5, 5, (sw * 77) + (picDump.Width - picDump.ScaleWidth), (sh * NumOfRows) + (picDump.Height - picDump.ScaleHeight)
    
    lblAddress.Top = picDump.Top + picDump.Height + 5
    txtAddress.Top = lblAddress.Top
    cmdRead.Top = txtAddress.Top
    
    Me.Width = (picDump.Width + 10 - Me.ScaleWidth) * Screen.TwipsPerPixelX + Me.Width
    Me.Height = (txtAddress.Top + 5 + txtAddress.Height - Me.ScaleHeight) * Screen.TwipsPerPixelY + Me.Height
    
    Update
    
End Sub

' //    
Private Sub Update()
    Dim col As Long
    Dim row As Long
    Dim ptr As Long
    Dim hxd As String
    Dim asi As String
    Dim adr As String
    Dim out As String
    
    For row = 0 To NumOfRows - 1

        adr = Hex(Address + row * 16)
        adr = String(8 - Len(adr), "0") & adr
        asi = ""
        hxd = ""
        
        For col = 0 To 15
            
            If ptr < bufLen Then
                
                hxd = hxd & " " & IIf(buffer(ptr) < &H10, "0" & Hex(buffer(ptr)), Hex(buffer(ptr)))
                asi = asi & IIf(buffer(ptr) >= 32, Chr$(buffer(ptr)), "?")
                
            Else

                hxd = hxd & " ??"
                asi = asi & "?"
                
            End If
            
            ptr = ptr + 1
            
        Next
        
        If row Then out = out & vbNewLine
        
        out = out & adr & ":" & hxd & " | " & asi
        
    Next
    
    picDump.Cls
    picDump.Print out
    
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Dim Status As SERVICE_STATUS
    
    ' //   
    CloseHandle hDev
    
    ' //  
    ControlService hSrv, SERVICE_CONTROL_STOP, Status
    
    ' //  
    DeleteService hSrv
    
    ' //  
    CloseServiceHandle hSrv
    CloseServiceHandle hMgr
    
End Sub
